﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;
using System.Resources;

namespace GenericValidation
{
    /// <summary>
    /// Base class for extensibility and defining object Member validations, like: RequiredField, StringLenght, Compare and RegEx validations.
    /// </summary>
    /// <typeparam name="TEntity">Object Type</typeparam>
    /// <typeparam name="TMember">Member Type</typeparam>
    public abstract  class MemberValidator<T, U> : Validator<T>
        where T:class
    {
        public MemberValidator(ValidationMember<T, U> member)
            : base(member.Validation, null)
        {
            this.Tag(member.MemberName);
        }
    }
}
